diff -Nurp '--exclude=.bzr*' tin-2.6.4/include/tinrc.h tin-2.6.5/include/tinrc.h
--- tin-2.6.4/include/tinrc.h	2024-12-21 15:10:30.000000000 +0100
+++ tin-2.6.5/include/tinrc.h	2025-11-17 19:30:04.971373476 +0100
@@ -3,10 +3,10 @@
  *  Module    : tinrc.h
  *  Author    : Jason Faultless <jason@altarstone.com>
  *  Created   : 1999-04-13
- *  Updated   : 2024-12-21
+ *  Updated   : 2025-11-17
  *  Notes     :
  *
- * Copyright (c) 1999-2025 Jason Faultless <jason@altarstone.com>
+ * Copyright (c) 1999-2026 Jason Faultless <jason@altarstone.com>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -80,6 +80,7 @@ struct t_config {
 	char *attachment_format;			/* format string for the attachment level */
 	char *page_mime_format;				/* format string for the mime header in page level */
 	char *page_uue_format;				/* format string for the uue header in page level */
+	char *page_yenc_format;				/* format string for the yenc header in page level */
 	char *date_format;					/* format string for the date display in the page header */
 	char *mail_quote_format;
 	char *mailer_format;				/* mailer + parameters  %M %S %T %F */
@@ -111,6 +112,7 @@ struct t_config {
 	char *underscores_regex;			/* regex used to highlight _underscores_ */
 	char *verbatim_begin_regex;			/* regex used to find the begin of a verbatim block */
 	char *verbatim_end_regex;			/* regex used to find the end of a verbatim block */
+	char *hideline_regex;				/* regex to skip over matching lines */
 	char *savedir;						/* directory to save articles to */
 	char *sigfile;
 	char *spamtrap_warning_addresses;
@@ -165,7 +167,7 @@ struct t_config {
 	int default_save_mode;				/* Append/Overwrite existing file when saving */
 	int getart_limit;					/* number of article to get */
 	int goto_next_unread;				/* jump to next unread article with SPACE|PGDN|TAB */
-	int hide_uue;						/* treatment of uuencoded data in pager */
+	int hide_inline_data;				/* handling of none text in pager */
 	int interactive_mailer;				/* invoke user's mailreader */
 	int kill_level;						/* Define how killed articles are shown */
 	int mono_markdash;					/* attribute for text highlighting with _underdashes_ */
@@ -205,6 +207,7 @@ struct t_config {
 	int thread_perc;					/* how close the match needs to be for THREAD_PERC to recognize two articles as the same thread */
 	int thread_score;					/* how the score for threads is computed */
 	int trim_article_body;				/* remove unnecessary blank lines */
+	int verbatim_handling;				/* Detection of verbatim blocks */
 	int wildcard;						/* 0=wildmat, 1=regex */
 	int word_h_display_marks;			/* display * or _ when highlighting or space or nothing */
 	int wrap_column;					/* screen column to wrap of text messages */
@@ -222,9 +225,9 @@ struct t_config {
 	t_bool beginner_level;				/* beginner level (shows mini help a la elm) */
 	t_bool cache_overview_files;		/* create local index files for NNTP overview files */
 	t_bool catchup_read_groups;			/* ask if read groups are to be marked read */
-#if defined(USE_ZLIB) && defined(CPP_DOES_CONCAT)
+#ifdef USE_ZLIB
 	t_bool compress_overview_files;		/* compress local index files (overview) with gz */
-#endif /* USE_ZLIB && CPP_DOES_CONCAT */
+#endif /* USE_ZLIB */
 	t_bool draw_arrow;					/* draw -> or highlighted bar */
 	t_bool dont_break_words;			/* don't break words when wrapping long lines */
 	t_bool force_screen_redraw;			/* force screen redraw after external (shell) commands */
@@ -232,6 +235,7 @@ struct t_config {
 	t_bool info_in_last_line;
 	t_bool inverse_okay;
 	t_bool keep_dead_articles;			/* keep all dead articles in dead.articles */
+	t_bool keep_expired_filters;		/* keep expired filter rules in file */
 	t_bool mail_8bit_header;			/* allow 8bit chars. in header of mail message */
 	t_bool mark_ignore_tags;			/* Ignore tags for GROUP_MARK_THREAD_READ/THREAD_MARK_ARTICLE_READ */
 	t_bool mark_saved_read;				/* mark saved article/thread as read */
@@ -266,7 +270,6 @@ struct t_config {
 #	if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
 		t_bool utf8_graphics;			/* use utf-8 characters for line drawing */
 #	endif /* MULTIBYTE_ABLE && !NO_LOCALE */
-	t_bool verbatim_handling;			/* Detection of verbatim blocks */
 #	ifdef HAVE_COLOR
 		t_bool extquote_handling;		/* Detection of quoted text from external sources */
 #	endif /* HAVE_COLOR */
@@ -290,7 +293,7 @@ struct t_config {
 	t_bool word_highlight;				/* like word_highlight but stored in tinrc */
 	t_bool wrap_on_next_unread;			/* Wrap around threads when searching next unread article */
 	/*
-	 * Chars used to show article status
+	 * Chars used to show article/scope status
 	 */
 #	if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
 		wchar_t art_marked_deleted;
@@ -302,6 +305,10 @@ struct t_config {
 		wchar_t art_marked_read;
 		wchar_t art_marked_killed;
 		wchar_t art_marked_read_selected;
+		wchar_t scope_marked_global;
+		wchar_t scope_marked_global_match;
+		wchar_t scope_marked_local;
+		wchar_t scope_marked_local_match;
 #	else
 		char art_marked_deleted;
 		char art_marked_inrange;		/* misnomer, as it's also used for other ranges */
@@ -312,6 +319,10 @@ struct t_config {
 		char art_marked_read;
 		char art_marked_killed;
 		char art_marked_read_selected;
+		char scope_marked_global;
+		char scope_marked_global_match;
+		char scope_marked_local;
+		char scope_marked_local_match;
 #	endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 	char *attrib_editor_format;
 	char *attrib_fcc;
@@ -345,7 +356,9 @@ struct t_config {
 		t_bool attrib_undeclared_cs_guess;
 #		endif /* USE_ICU_UCSDET */
 #	endif /* !CHARSET_CONVERSION */
+	int attrib_hide_inline_data;
 	int attrib_trim_article_body;
+	int attrib_verbatim_handling;
 	int attrib_auto_cc_bcc;
 	int attrib_quick_kill_header;
 	int attrib_quick_select_header;
@@ -357,6 +370,7 @@ struct t_config {
 	int attrib_sort_threads_type;
 	int attrib_thread_articles;
 	int attrib_thread_perc;
+	int attrib_getart_limit;
 	t_bool attrib_add_posted_to_filter;
 	t_bool attrib_advertising;
 	t_bool attrib_alternative_handling;
@@ -387,7 +401,6 @@ struct t_config {
 #	endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 	t_bool attrib_tex2iso_conv;
 	t_bool attrib_thread_catchup_on_exit;
-	t_bool attrib_verbatim_handling;
 #	ifdef HAVE_COLOR
 		t_bool attrib_extquote_handling;
 #	endif /* HAVE_COLOR */
@@ -398,6 +411,31 @@ struct t_config {
 	t_bool attrib_quick_kill_expire;
 	t_bool attrib_quick_select_case;
 	t_bool attrib_quick_select_expire;
+	char *serverrc_add_cmd_line_opts;
+	char *serverrc_disabled_nntp_cmds;
+	int serverrc_nntp_pipeline_limit;
+	t_bool serverrc_cache_overview_files;
+#	ifdef USE_ZLIB
+	t_bool serverrc_compress_overview_files;
+#	endif /* USE_ZLIB */
+};
+
+
+#	define SRVRC_MASK_UPDATE_INDEX		(1 << 0)	/* cmd.-line -u vs. serverrc -G */
+#	define SRVRC_MASK_READ_SAVED_NEWS	(1 << 1)	/* cmd.-line -R	vs. serverrc -t */
+struct t_serverrc {
+#	if 0 /* we don't need the outside read_server_config() */
+	char *version;
+	char *last_newnews;
+#	endif /* 0 */
+	char *add_cmd_line_opts;
+	char *disabled_nntp_cmds;
+	long motd_hash;
+	int nntp_pipeline_limit;
+	t_bool cache_overview_files;
+#	ifdef USE_ZLIB
+	t_bool compress_overview_files;
+#	endif /* USE_ZLIB */
 };
 
 #endif /* !TINRC_H */
diff -Nurp '--exclude=.bzr*' tin-2.6.4/include/tnntp.h tin-2.6.5/include/tnntp.h
--- tin-2.6.4/include/tnntp.h	2024-11-25 20:44:39.000000000 +0100
+++ tin-2.6.5/include/tnntp.h	2025-11-13 02:24:12.959177465 +0100
@@ -6,7 +6,7 @@
  *  Updated   : 2024-01-19
  *  Notes     : #include files, #defines & struct's
  *
- * Copyright (c) 1997-2025 Thomas Dickey <dickey@invisible-island.net>
+ * Copyright (c) 1997-2026 Thomas Dickey <dickey@invisible-island.net>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
diff -Nurp '--exclude=.bzr*' tin-2.6.4/include/tnntps.h tin-2.6.5/include/tnntps.h
--- tin-2.6.4/include/tnntps.h	2024-11-25 20:44:39.000000000 +0100
+++ tin-2.6.5/include/tnntps.h	2025-11-13 02:24:12.963177639 +0100
@@ -6,7 +6,7 @@
  *  Updated   : 2022-12-13
  *  Notes     : TLS #include files, #defines & struct's
  *
- * Copyright (c) 2022-2025 Enrik Berkhan <Enrik.Berkhan@inka.de>
+ * Copyright (c) 2022-2026 Enrik Berkhan <Enrik.Berkhan@inka.de>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
diff -Nurp '--exclude=.bzr*' tin-2.6.4/include/trace.h tin-2.6.5/include/trace.h
--- tin-2.6.4/include/trace.h	2024-11-25 20:44:39.000000000 +0100
+++ tin-2.6.5/include/trace.h	2025-11-13 02:24:12.967177814 +0100
@@ -6,7 +6,7 @@
  *  Updated   : 2002-11-10
  *  Notes     : Interface of trace.c
  *
- * Copyright (c) 1997-2025 Thomas Dickey <dickey@invisible-island.net>
+ * Copyright (c) 1997-2026 Thomas Dickey <dickey@invisible-island.net>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
diff -Nurp '--exclude=.bzr*' tin-2.6.4/include/version.h tin-2.6.5/include/version.h
--- tin-2.6.4/include/version.h	2024-12-24 00:18:40.000000000 +0100
+++ tin-2.6.5/include/version.h	2025-12-24 00:14:31.838306234 +0100
@@ -6,7 +6,7 @@
  *  Updated   : 2021-02-01
  *  Notes     :
  *
- * Copyright (c) 1991-2025 Iain Lea <iain@bricbrac.de>
+ * Copyright (c) 1991-2026 Iain Lea <iain@bricbrac.de>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -43,15 +43,15 @@
 
 #	define PRODUCT		"tin"
 #	ifndef TIN_AUTOCONF_H
-#		define VERSION		"2.6.4"
+#		define VERSION		"2.6.5"
 #	endif /* !TIN_AUTOCONF_H */
-#	define RELEASEDATE	"20241224"
-#	define RELEASENAME	"Helmsdale"
+#	define RELEASEDATE	"20251224"
+#	define RELEASENAME	"Glenury"
 /* config-file versions - must be dotted triples in the range 0 to 99 each */
-#	define TINRC_VERSION	"1.3.18"
-#	define ATTRIBUTES_VERSION	"1.0.11"
+#	define TINRC_VERSION	"1.3.20"
+#	define ATTRIBUTES_VERSION	"1.0.13"
 #	define FILTER_VERSION	"1.0.2"
-#	define KEYMAP_VERSION	"1.0.11"
-#	define SERVERCONFIG_VERSION	"1.0.0"
+#	define KEYMAP_VERSION	"1.0.12"
+#	define SERVERCONFIG_VERSION	"1.0.1"
 
 #endif /* !VERSION_H */
diff -Nurp '--exclude=.bzr*' tin-2.6.4/po-man/de.add tin-2.6.5/po-man/de.add
--- tin-2.6.4/po-man/de.add	1970-01-01 01:00:00.000000000 +0100
+++ tin-2.6.5/po-man/de.add	2025-07-21 15:32:40.291972160 +0200
@@ -0,0 +1,6 @@
+PO4A-HEADER: mode=after; position=MAINTAINER;beginboundary=^\.SH
+.SH ÜBERSETZUNG
+.IP "Erika Mustermann <erika@example.org>"
+Wenn Sie Fehler in der Übersetzung finden, dürfen Sie diese gerne per
+E-Mail an <translation@tin.org> melden.
+.\"
diff -Nurp '--exclude=.bzr*' tin-2.6.4/po4a.conf tin-2.6.5/po4a.conf
--- tin-2.6.4/po4a.conf	2023-08-01 18:58:40.000000000 +0200
+++ tin-2.6.5/po4a.conf	2025-07-23 01:26:33.018981507 +0200
@@ -1,16 +1,17 @@
-[po_directory] doc/l10n
+[po_directory] po-man
 
 [options] \
         opt:"-k 0 --master-charset UTF-8" \
         opt_de:"-L UTF-8 -A UTF-8" \
         opt_en_GB:"-L UTF-8 -A UTF-8" \
-        opt_es:"-L UTF-8 -A UTF-8"
+        opt_es:"-L UTF-8 -A UTF-8" \
+        opt_ro:"-L UTF-8 -A UTF-8"
 
 [type: man] doc/tin.1 \
-	$lang:doc/l10n/$lang/tin.1 \
-	add_$lang:?doc/l10n/$lang.add \
+	$lang:po-man/$lang/tin.1 \
+	add_$lang:?po-man/$lang.add \
 	opt:"-v"
 
 [type: man] doc/tin.5 \
-	$lang:doc/l10n/$lang/tin.5 \
+	$lang:po-man/$lang/tin.5 \
 	opt:"-v"
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/active.c tin-2.6.5/src/active.c
--- tin-2.6.4/src/active.c	2024-12-16 02:34:04.000000000 +0100
+++ tin-2.6.5/src/active.c	2025-11-19 07:30:17.903367658 +0100
@@ -3,10 +3,10 @@
  *  Module    : active.c
  *  Author    : I. Lea
  *  Created   : 1992-02-16
- *  Updated   : 2024-12-16
+ *  Updated   : 2025-11-19
  *  Notes     :
  *
- * Copyright (c) 1992-2025 Iain Lea <iain@bricbrac.de>
+ * Copyright (c) 1992-2026 Iain Lea <iain@bricbrac.de>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -44,9 +44,6 @@
 #ifndef TCURSES_H
 #	include "tcurses.h"
 #endif /* !TCURSES_H */
-#ifndef STPWATCH_H
-#	include "stpwatch.h"
-#endif /* !STPWATCH_H */
 
 /*
  * List of allowed separator chars in active file
@@ -54,14 +51,6 @@
  */
 #define ACTIVE_SEP	" \n"
 
-#ifdef NNTP_ABLE
-#	ifdef DISABLE_PIPELINING
-#		define NUM_SIMULTANEOUS_GROUP_COMMAND 1
-#	else
-#		define NUM_SIMULTANEOUS_GROUP_COMMAND 50
-#	endif /* DISABLE_PIPELINING */
-#endif /* NNTP_ABLE */
-
 t_bool force_reread_active_file = FALSE;
 static time_t active_timestamp;	/* time active file read (local) */
 
@@ -72,7 +61,6 @@ static time_t active_timestamp;	/* time
 static FILE *open_newgroups_fp(int idx);
 static FILE *open_news_active_fp(void);
 static int check_for_any_new_groups(void);
-static void active_add(struct t_group *ptr, t_artnum count, t_artnum max, t_artnum min, const char *moderated);
 static void append_group_line(const char *active_file, const char *group_path, t_artnum art_max, t_artnum art_min, char *base_dir);
 static void make_group_list(char *active_file, char *base_dir, char *fixed_base, char *group_path);
 static void read_active_file(void);
@@ -117,7 +105,7 @@ resync_active_file(
 		old_group = my_strdup(CURR_GROUP.name);
 
 	write_newsrc();
-	read_news_active_file(FALSE);
+	read_news_active_file();
 
 #ifdef HAVE_MH_MAIL_HANDLING
 	read_mail_active_file();
@@ -145,7 +133,7 @@ resync_active_file(
  * TODO: 1) Have a preinitialised default slot and block assign it for speed
  * TODO: 2) Lump count/max/min/moderat into a t_active, big patch but much cleaner throughout tin
  */
-static void
+void
 active_add(
 	struct t_group *ptr,
 	t_artnum count,
@@ -172,6 +160,7 @@ active_add(
 	ptr->newsrc.xbitmap = (t_bitmap *) 0;
 	ptr->attribute = (struct t_attribute *) 0;
 	ptr->glob_filter = &glob_filter;
+	ptr->scopes_list = NULL;
 	set_default_bitmap(ptr);
 
 	if (moderated[0] == '/') {
@@ -270,6 +259,7 @@ parse_active_line(
 	*min = atoartnum(q);
 
 	if (!lineok) { /* missing moderation flag - seen on usenet.farm */
+		/* TODO: don't do the y-guessing with mail-active-files */
 		strcpy(moderated, "y");	/* guess posting is fine */
 		lineok = TRUE;
 	} else
@@ -351,16 +341,15 @@ do_read_newsrc_active_file(
 {
 	char *ptr;
 	char *p;
-	char moderated[PATH_LEN];
 	int window = 0;
 	long processed = 0L;
 	t_artnum count = T_ARTNUM_CONST(-1), min = T_ARTNUM_CONST(1), max = T_ARTNUM_CONST(0);
 	static char ngname[NNTP_GRPLEN + 1]; /* RFC 3977 3.1 limits group names to 497 octets */
-	struct t_group *grpptr;
+	struct t_group *grpptr = NULL;
 	t_bool changed;
 #ifdef NNTP_ABLE
 	t_bool need_auth = FALSE;
-	char *ngnames[NUM_SIMULTANEOUS_GROUP_COMMAND] = { NULL };
+	char **ngnames = my_calloc(serverrc.nntp_pipeline_limit, sizeof(char *));
 	char fmt[25];
 	char buf[NNTP_STRLEN];
 	char line[NNTP_STRLEN];
@@ -378,9 +367,9 @@ do_read_newsrc_active_file(
 	while ((ptr = tin_fgets(fp, FALSE)) != NULL || window != 0) {
 		if (ptr) {
 			p = strpbrk(ptr, ":!");
-
 			if (!p || *p != SUBSCRIBED)	/* Invalid line or unsubscribed */
 				continue;
+
 			*p = '\0';			/* Now ptr is the group name */
 
 			/*
@@ -394,7 +383,9 @@ do_read_newsrc_active_file(
 
 		if (read_news_via_nntp && !read_saved_news) { /* this should be limited to GROUP_TYPE_NEWS, but ... */
 #ifdef NNTP_ABLE
-			if (window < NUM_SIMULTANEOUS_GROUP_COMMAND && ptr && (!list_active || (newsrc_active && group_find(ptr, FALSE)))) {
+			if (window < serverrc.nntp_pipeline_limit && ptr && (!list_active || (newsrc_active && (grpptr = group_find(ptr, FALSE))))) {
+				if (grpptr && grpptr->type != GROUP_TYPE_NEWS) /* skip mailgroups in -ln case */
+					continue;
 				ngnames[index_i] = my_strdup(ptr);
 				snprintf(buf, sizeof(buf), "GROUP %s", ngnames[index_i]);
 #	ifdef DEBUG
@@ -402,10 +393,10 @@ do_read_newsrc_active_file(
 					debug_print_file("NNTP", "read_newsrc_active_file() %s", buf);
 #	endif /* DEBUG */
 				put_server(buf, FALSE);
-				index_i = (index_i + 1) % NUM_SIMULTANEOUS_GROUP_COMMAND;
+				index_i = (index_i + 1) % serverrc.nntp_pipeline_limit;
 				++window;
 			}
-			if (window == NUM_SIMULTANEOUS_GROUP_COMMAND || ptr == NULL) {
+			if (window == serverrc.nntp_pipeline_limit || ptr == NULL) {
 				respcode = get_only_respcode(line, sizeof(line));
 
 				if (reconnected_in_last_get_server) {
@@ -424,12 +415,12 @@ do_read_newsrc_active_file(
 							debug_print_file("NNTP", "read_newsrc_active_file() %s", buf);
 #	endif /* DEBUG */
 						put_server(buf, FALSE);
-						j = (j + 1) % NUM_SIMULTANEOUS_GROUP_COMMAND;
+						j = (j + 1) % serverrc.nntp_pipeline_limit;
 					}
 					if (--index_o < 0)
-						index_o = NUM_SIMULTANEOUS_GROUP_COMMAND - 1;
+						index_o = serverrc.nntp_pipeline_limit - 1;
 					if (--index_i < 0)
-						index_i = NUM_SIMULTANEOUS_GROUP_COMMAND - 1;
+						index_i = serverrc.nntp_pipeline_limit - 1;
 					if (index_i != index_o)
 						ngnames[index_o] = ngnames[index_i];
 				}
@@ -447,8 +438,8 @@ do_read_newsrc_active_file(
 #	endif /* DEBUG */
 							}
 							ptr = ngname;
-							free(ngnames[index_o]);
-							index_o = (index_o + 1) % NUM_SIMULTANEOUS_GROUP_COMMAND;
+							FreeAndNull(ngnames[index_o]);
+							index_o = (index_o + 1) % serverrc.nntp_pipeline_limit;
 							--window;
 							break;
 						}
@@ -460,16 +451,22 @@ do_read_newsrc_active_file(
 						/* FALLTHROUGH */
 
 					case ERR_NOGROUP:
-						free(ngnames[index_o]);
-						index_o = (index_o + 1) % NUM_SIMULTANEOUS_GROUP_COMMAND;
+						FreeAndNull(ngnames[index_o]);
+						index_o = (index_o + 1) % serverrc.nntp_pipeline_limit;
 						--window;
 						continue;
 
 					case ERR_ACCESS:
-						for (index_i = 0; index_i < NUM_SIMULTANEOUS_GROUP_COMMAND - 1; index_i++) {
-							FreeIfNeeded(ngnames[index_i]);
+						{
+							char bbuf[4 + NNTP_GRPLEN + NNTP_STRLEN + 3 + 1];
+
+							snprintf(bbuf, sizeof(bbuf), "%d %s (%s)", respcode, line, BlankIfNull(ngnames[index_o]));
+							for (index_i = 0; index_i < serverrc.nntp_pipeline_limit - 1; ++index_i) {
+								FreeIfNeeded(ngnames[index_i]);
+							}
+							free(ngnames);
+							tin_done(NNTP_ERROR_EXIT, "%s", bbuf);
 						}
-						tin_done(NNTP_ERROR_EXIT, "%s", line);
 						/* keep lint quiet: */
 						/* FALLTHROUGH */
 
@@ -478,8 +475,8 @@ do_read_newsrc_active_file(
 						if ((debug & DEBUG_NNTP) && verbose > 1)
 							debug_print_file("NNTP", "NOT_OK %s", line);
 #	endif /* DEBUG */
-						free(ngnames[index_o]);
-						index_o = (index_o + 1) % NUM_SIMULTANEOUS_GROUP_COMMAND;
+						FreeAndNull(ngnames[index_o]);
+						index_o = (index_o + 1) % serverrc.nntp_pipeline_limit;
 						--window;
 						continue;
 				}
@@ -487,12 +484,19 @@ do_read_newsrc_active_file(
 				continue;
 #endif /* NNTP_ABLE */
 		} else {
+			/*
+			 * -n on local spool may give false results as the
+			 * server may have removed the groups dir when all
+			 * articles are expired/cancelled or no articles
+			 * haven been posted yet. as we did not check the
+			 * active file we just don't know if that's the case
+			 * and the group is valid or we have a bogus group
+			 * here.
+			 */
 			if (group_get_art_info(spooldir, ptr, GROUP_TYPE_NEWS, &count, &max, &min))
 				continue;
 		}
 
-		strcpy(moderated, "y");
-
 		if (++processed % 5 == 0)
 			spin_cursor();
 
@@ -524,10 +528,12 @@ do_read_newsrc_active_file(
 
 		/*
 		 * Load the new group in active[]
+		 * as we don't know the group flag, assume y
 		 */
-		active_add(grpptr, count, max, min, moderated);
+		active_add(grpptr, count, max, min, "y");
 	}
 #ifdef NNTP_ABLE
+	free(ngnames);
 	return need_auth;
 #endif /* NNTP_ABLE */
 }
@@ -614,9 +620,6 @@ read_active_file(
 	struct t_group *grpptr;
 	t_artnum count = T_ARTNUM_CONST(-1), min = T_ARTNUM_CONST(1), max = T_ARTNUM_CONST(0);
 
-	if (!batch_mode || verbose)
-		wait_message(0, _(txt_reading_news_active_file));
-
 	if ((fp = open_news_active_fp()) == NULL) {
 		if ((cmd_line && !batch_mode) || verbose)
 			my_fputc('\n', stderr);
@@ -636,6 +639,9 @@ read_active_file(
 #endif /* NNTP_ABLE */
 	}
 
+	if (!batch_mode || verbose)
+		wait_message(0, _(txt_reading_news_active_file));
+
 	while ((ptr = tin_fgets(fp, FALSE)) != NULL) {
 #if defined(DEBUG) && defined(NNTP_ABLE)
 		if ((debug & DEBUG_NNTP) && verbose) /* long multiline response */
@@ -781,14 +787,14 @@ read_active_counts(
  */
 int
 read_news_active_file(
-	t_bool check_any_unread)
+	void)
 {
 	FILE *fp;
 	int newgrps = 0;
 	t_bool do_group_cmds = !nntp_caps.list_counts;
-#if defined(NNTP_ABLE) && !defined(DISABLE_PIPELINING)
-	t_bool did_list_cmd = FALSE;
-#endif /* NNTP_ABLE && !DISABLE_PIPELINING */
+#ifdef NNTP_ABLE
+	t_bool did_list_cmd = (serverrc.nntp_pipeline_limit == PIPELINE_LIMIT_MIN);
+#endif /* NNTP_ABLE */
 
 	/*
 	 * Ignore -n if no .newsrc can be found or .newsrc is empty
@@ -804,9 +810,8 @@ read_news_active_file(
 	/* Read an active file if it is allowed */
 	if (list_active) {
 #ifdef NNTP_ABLE
-#	ifndef DISABLE_PIPELINING
-		did_list_cmd = TRUE;
-#	endif /* !DISABLE_PIPELINING */
+		if (serverrc.nntp_pipeline_limit > PIPELINE_LIMIT_MIN) /* !DISABLE_PIPELINING */
+			did_list_cmd = TRUE;
 		if (read_news_via_nntp && nntp_caps.list_counts)
 			read_active_counts();
 		else
@@ -817,118 +822,120 @@ read_news_active_file(
 	/* Read .newsrc and check each group */
 	if (newsrc_active) {
 #ifdef NNTP_ABLE
-#	ifndef DISABLE_PIPELINING
-		/*
-		 * prefer LIST COUNTS, otherwise use LIST ACTIVE (-l) or GROUP (-n)
-		 * or both (-ln); LIST COUNTS/ACTIVE grplist is used up to
-		 * PIPELINE_LIMIT groups in newsrc
-		 */
-		if (read_news_via_nntp && (list_active || nntp_caps.list_counts) && !did_list_cmd) {
-			/* we can't use for_each_group(i) yet, so we have to parse the newsrc */
-			if ((fp = tin_fopen(newsrc, "r")) != NULL) {
-				char buff[NNTP_STRLEN];
-				char moderated[PATH_LEN];
-				char *ptr, *q;
-				int r = 0, j = 0;
-				int i;
-				t_artnum count = T_ARTNUM_CONST(-1), min = T_ARTNUM_CONST(1), max = T_ARTNUM_CONST(0);
-				struct t_group *grpptr;
-				t_bool need_auth = FALSE;
-
-				*buff = '\0';
-				while (tin_fgets(fp, FALSE) != NULL)
-					++j;
-				rewind(fp);
-				if (j < PIPELINE_LIMIT) {
-					while ((ptr = tin_fgets(fp, FALSE)) != NULL) {
-						if (!(q = strpbrk(ptr, ":!")))
-							continue;
-						*q = '\0';
-						if (nntp_caps.type == CAPABILITIES && (nntp_caps.list_active || nntp_caps.list_counts)) {
-							/* LIST ACTIVE or LIST COUNTS takes wildmats */
-							if (*buff && ((strlen(buff) + strlen(ptr)) < (NNTP_GRPLEN - 1))) { /* append group name */
-								snprintf(buff + strlen(buff), sizeof(buff) - strlen(buff), ",%s", ptr);
-							} else {
-								if (*buff) {
-									put_server(buff, FALSE);
-									++r;
+		if (serverrc.nntp_pipeline_limit > PIPELINE_LIMIT_MIN) { /* !DISABLE_PIPELINING */
+			/*
+			 * prefer LIST COUNTS, otherwise use LIST ACTIVE (-l) or GROUP (-n)
+			 * or both (-ln); LIST COUNTS/ACTIVE grplist is used up to
+			 * serverrc.nntp_pipeline_limit groups in newsrc
+			 */
+			if (read_news_via_nntp && (list_active || nntp_caps.list_counts) && !did_list_cmd) {
+				/* we can't use for_each_group(i) yet, so we have to parse the newsrc */
+				if ((fp = tin_fopen(newsrc, "r")) != NULL) {
+					char buff[NNTP_STRLEN];
+					char moderated[PATH_LEN];
+					char *ptr, *q;
+					int r = 0, j = 0;
+					int i;
+					t_artnum count = T_ARTNUM_CONST(-1), min = T_ARTNUM_CONST(1), max = T_ARTNUM_CONST(0);
+					struct t_group *grpptr;
+					t_bool need_auth = FALSE;
+
+					*buff = '\0';
+					while (tin_fgets(fp, FALSE) != NULL)
+						++j;
+					rewind(fp);
+					if (j < serverrc.nntp_pipeline_limit) {
+						while ((ptr = tin_fgets(fp, FALSE)) != NULL) {
+							if (!(q = strpbrk(ptr, ":!")))
+								continue;
+
+							*q = '\0';
+							if (nntp_caps.type == CAPABILITIES && (nntp_caps.list_active || nntp_caps.list_counts)) {
+								/* LIST ACTIVE or LIST COUNTS takes wildmats */
+								if (*buff && ((strlen(buff) + strlen(ptr)) < (NNTP_GRPLEN - 1))) /* append group name */
+									snprintf(buff + strlen(buff), sizeof(buff) - strlen(buff), ",%s", ptr);
+								else {
+									if (*buff) {
+										put_server(buff, FALSE);
+										++r;
+									}
+									snprintf(buff, sizeof(buff), "LIST %s %s", nntp_caps.list_counts ? "COUNTS" : "ACTIVE", ptr);
 								}
-								snprintf(buff, sizeof(buff), "LIST %s %s", nntp_caps.list_counts ? "COUNTS" : "ACTIVE", ptr);
-							}
-							continue;
-						} else
-							snprintf(buff, sizeof(buff), "LIST ACTIVE %s", ptr);
-						put_server(buff, FALSE);
-						++r;
-						*buff = '\0';
-					}
-					if (*buff) {
-						put_server(buff, FALSE);
-						++r;
-					}
-				} else
-					do_group_cmds = TRUE;
+								continue;
+							} else
+								snprintf(buff, sizeof(buff), "LIST ACTIVE %s", ptr);
+
+							put_server(buff, FALSE);
+							++r;
+							*buff = '\0';
+						}
+						if (*buff) {
+							put_server(buff, FALSE);
+							++r;
+						}
+					} else
+						do_group_cmds = TRUE;
 
-				fclose(fp);
+					fclose(fp);
 
-				if (j < PIPELINE_LIMIT) {
-					for (i = 0; i < r && !did_reconnect; i++) {
-						if ((j = get_only_respcode(buff, sizeof(buff))) != OK_GROUPS) {
-							/* TODO: add 483 (RFC 3977) code */
-							if (j == ERR_NOAUTH || j == NEED_AUTHINFO)
-								need_auth = TRUE;
+					if (j < serverrc.nntp_pipeline_limit) {
+						for (i = 0; i < r && !did_reconnect; i++) {
+							if ((j = get_only_respcode(buff, sizeof(buff))) != OK_GROUPS) {
+								/* TODO: add 483 (RFC 3977) code */
+								if (j == ERR_NOAUTH || j == NEED_AUTHINFO)
+									need_auth = TRUE;
 #		if 0 /* do we need something like this? */
-							if (j == ERR_CMDSYN)
-								list_active = TRUE;
+								if (j == ERR_CMDSYN)
+									list_active = TRUE;
 #		endif /* 0 */
-							continue;
-						} else {
-							while ((ptr = tin_fgets(FAKE_NNTP_FP, FALSE)) != NULL) {
+								continue;
+							} else {
+								while ((ptr = tin_fgets(FAKE_NNTP_FP, FALSE)) != NULL) {
 #		ifdef DEBUG
-								if ((debug & DEBUG_NNTP) && verbose) /* long multiline response */
-									debug_print_file("NNTP", "<<<%s%s", logtime(), ptr);
+									if ((debug & DEBUG_NNTP) && verbose) /* long multiline response */
+										debug_print_file("NNTP", "<<<%s%s", logtime(), ptr);
 #		endif /* DEBUG */
-								if (nntp_caps.type == CAPABILITIES && nntp_caps.list_counts) {
-									if (!parse_count_line(ptr, &max, &min, &count, moderated))
-										continue;
-								} else {
-									if (!parse_active_line(ptr, &max, &min, moderated))
-										continue;
-								}
+									if (nntp_caps.list_counts) {
+										if (!parse_count_line(ptr, &max, &min, &count, moderated))
+											continue;
+									} else {
+										if (!parse_active_line(ptr, &max, &min, moderated))
+											continue;
+									}
 
-								if ((grpptr = group_add(ptr)) == NULL) {
-									if ((grpptr = group_find(ptr, FALSE)) == NULL)
+									if ((grpptr = group_add(ptr)) == NULL) {
+										if ((grpptr = group_find(ptr, FALSE)) == NULL)
+											continue;
+
+										if (max > grpptr->xmax) {
+											grpptr->xmax = max;
+											grpptr->count = count;
+										}
+										if (min > grpptr->xmin) {
+											grpptr->xmin = min;
+											grpptr->count = count;
+										}
 										continue;
-
-									if (max > grpptr->xmax) {
-										grpptr->xmax = max;
-										grpptr->count = count;
-									}
-									if (min > grpptr->xmin) {
-										grpptr->xmin = min;
-										grpptr->count = count;
 									}
-									continue;
+									active_add(grpptr, count, max, min, moderated);
 								}
-								active_add(grpptr, count, max, min, moderated);
-							}
 #		ifdef DEBUG
-							/* log end of multiline response to get timing data */
-							if ((debug & DEBUG_NNTP) && !verbose)
-								debug_print_file("NNTP", "<<<%s%s", logtime(), txt_log_data_hidden);
+								/* log end of multiline response to get timing data */
+								if ((debug & DEBUG_NNTP) && !verbose)
+									debug_print_file("NNTP", "<<<%s%s", logtime(), txt_log_data_hidden);
 #		endif /* DEBUG */
+							}
+						}
+						if (need_auth) { /* retry after auth is overkill here, so just auth */
+							if (!authenticate(nntp_server, userid, FALSE))
+								tin_done(EXIT_FAILURE, _(txt_auth_failed), nntp_caps.type == CAPABILITIES ? ERR_AUTHFAIL : ERR_ACCESS);
+							/* no set_maxartnum() here after auth as we're pipelining ... */
 						}
 					}
-					if (need_auth) { /* retry after auth is overkill here, so just auth */
-						if (!authenticate(nntp_server, userid, FALSE))
-							tin_done(EXIT_FAILURE, _(txt_auth_failed), nntp_caps.type == CAPABILITIES ? ERR_AUTHFAIL : ERR_ACCESS);
-						/* no set_maxartnum() here after auth as we're pipelining ... */
-					}
+					did_reconnect = FALSE;
 				}
-				did_reconnect = FALSE;
 			}
 		}
-#	endif /* !DISABLE_PIPELINING */
 #endif /* NNTP_ABLE */
 		if (!nntp_caps.list_counts || do_group_cmds)
 			read_newsrc_active_file();
@@ -943,16 +950,6 @@ read_news_active_file(
 	if (check_for_new_newsgroups)
 		newgrps = check_for_any_new_groups();
 
-	/*
-	 * finally we have a list of all groups and can set the attributes
-	 * if required
-	 */
-	if (!check_any_unread) {
-		BegStopWatch();
-		assign_attributes_to_groups();
-		EndStopWatch("assign_attributes_to_groups()");
-	}
-
 	return newgrps;
 }
 
@@ -967,7 +964,7 @@ open_newgroups_fp(
 	int idx)
 {
 #ifdef NNTP_ABLE
-	if (read_news_via_nntp && !read_saved_news) {
+	if (read_news_via_nntp && !read_saved_news && nntp_caps.newgroups) {
 		char line[NNTP_STRLEN];
 		const struct tm *ngtm;
 
@@ -1010,7 +1007,11 @@ open_newgroups_fp(
 	(void) idx;
 #endif /* NNTP_ABLE */
 
+#ifndef NNTP_ONLY
 	return (fopen(active_times_file, "r"));
+#else
+	return (FILE *) 0;
+#endif /* !NNTP_ONLY */
 }
 
 
@@ -1206,14 +1207,14 @@ match_group_list(
 		 * copy out the entry and terminate it properly
 		 */
 		my_strncpy(pattern, group_list, group_len);
-		my_strncpy(ngname, group, sizeof(ngname) - 1);
 		str_lwr(pattern);
+		my_strncpy(ngname, group, sizeof(ngname) - 1);
 		str_lwr(ngname);
 
 		/*
 		 * "case-insensitive" (str_lwr(); avoid malloc()/free() in) wildcard match
 		 */
-		if (GROUP_MATCH(group, pattern, FALSE))
+		if (GROUP_MATCH(ngname, pattern, FALSE))
 			accept = bool_not(negate);	/* matched! */
 
 		/*
@@ -1236,7 +1237,7 @@ match_group_list(
  */
 void
 load_newnews_info(
-	char *info)
+	const char *info)
 {
 	char *ptr;
 	int i;
